org.opencv.xfeatures2d

## Class SURF

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features2d.Feature2D
    - - org.opencv.xfeatures2d.SURF

-     public class SURF
      extends Feature2D

  Class for extracting Speeded Up Robust Features from an image CITE: Bay06 . The algorithm parameters:
  - member int extended
    - 0 means that the basic descriptors (64 elements each) shall be computed
    - 1 means that the extended descriptors (128 elements each) shall be computed
  - member int upright
    - 0 means that detector computes orientation of each feature.
    - 1 means that the orientation is not computed (which is much, much faster). For example, if you match images from a stereo pair, or do image stitching, the matched features likely have very similar angles, and you can speed up feature extraction by setting upright=1.
  - member double hessianThreshold Threshold for the keypoint detector. Only features, whose hessian is larger than hessianThreshold are retained by the detector. Therefore, the larger the value, the less keypoints you will get. A good default value could be from 300 to 500, depending from the image contrast.
  - member int nOctaves The number of a gaussian pyramid octaves that the detector uses. It is set to 4 by default. If you want to get very large features, use the larger value. If you want just small features, decrease it.
  - member int nOctaveLayers The number of images within each octave of a gaussian pyramid. It is set to 2 by default.
  Note:
  - An example using the SURF feature detector can be found at opencv_source_code/samples/cpp/generic_descriptor_match.cpp
    - Another example using the SURF feature detector, extractor and matcher can be found at opencv_source_code/samples/cpp/matcher_simple.cpp

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SURF(long addr)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static SURF` | `__fromPtr__(long addr)`
    `static SURF` | `create()` 64-element descriptors).
    `static SURF` | `create(double hessianThreshold)`
    `static SURF` | `create(double hessianThreshold, int nOctaves)`
    `static SURF` | `create(double hessianThreshold, int nOctaves, int nOctaveLayers)`
    `static SURF` | `create(double hessianThreshold, int nOctaves, int nOctaveLayers, boolean extended)`
    `static SURF` | `create(double hessianThreshold, int nOctaves, int nOctaveLayers, boolean extended, boolean upright)`
    `protected void` | `finalize()`
    `boolean` | `getExtended()`
    `double` | `getHessianThreshold()`
    `int` | `getNOctaveLayers()`
    `int` | `getNOctaves()`
    `boolean` | `getUpright()`
    `void` | `setExtended(boolean extended)`
    `void` | `setHessianThreshold(double hessianThreshold)`
    `void` | `setNOctaveLayers(int nOctaveLayers)`
    `void` | `setNOctaves(int nOctaves)`
    `void` | `setUpright(boolean upright)`

    - ### Methods inherited from class org.opencv.features2d.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, getDefaultName, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SURF

          protected SURF(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static SURF __fromPtr__(long addr)

    - #### create

          public static SURF create(double hessianThreshold,
                                    int nOctaves,
                                    int nOctaveLayers,
                                    boolean extended,
                                    boolean upright)

      Parameters:
        `hessianThreshold` - Threshold for hessian keypoint detector used in SURF.
        `nOctaves` - Number of pyramid octaves the keypoint detector will use.
        `nOctaveLayers` - Number of octave layers within each octave.
        `extended` - Extended descriptor flag (true - use extended 128-element descriptors; false - use 64-element descriptors).
        `upright` - Up-right or rotated features flag (true - do not compute orientation of features; false - compute orientation).
      Returns:
        automatically generated

    - #### create

          public static SURF create(double hessianThreshold,
                                    int nOctaves,
                                    int nOctaveLayers,
                                    boolean extended)

      Parameters:
        `hessianThreshold` - Threshold for hessian keypoint detector used in SURF.
        `nOctaves` - Number of pyramid octaves the keypoint detector will use.
        `nOctaveLayers` - Number of octave layers within each octave.
        `extended` - Extended descriptor flag (true - use extended 128-element descriptors; false - use 64-element descriptors). false - compute orientation).
      Returns:
        automatically generated

    - #### create

          public static SURF create(double hessianThreshold,
                                    int nOctaves,
                                    int nOctaveLayers)

      Parameters:
        `hessianThreshold` - Threshold for hessian keypoint detector used in SURF.
        `nOctaves` - Number of pyramid octaves the keypoint detector will use.
        `nOctaveLayers` - Number of octave layers within each octave. 64-element descriptors). false - compute orientation).
      Returns:
        automatically generated

    - #### create

          public static SURF create(double hessianThreshold,
                                    int nOctaves)

      Parameters:
        `hessianThreshold` - Threshold for hessian keypoint detector used in SURF.
        `nOctaves` - Number of pyramid octaves the keypoint detector will use. 64-element descriptors). false - compute orientation).
      Returns:
        automatically generated

    - #### create

          public static SURF create(double hessianThreshold)

      Parameters:
        `hessianThreshold` - Threshold for hessian keypoint detector used in SURF. 64-element descriptors). false - compute orientation).
      Returns:
        automatically generated

    - #### create

          public static SURF create()

      64-element descriptors). false - compute orientation).
      Returns:
        automatically generated

    - #### getExtended

          public boolean getExtended()

    - #### getUpright

          public boolean getUpright()

    - #### getHessianThreshold

          public double getHessianThreshold()

    - #### getNOctaveLayers

          public int getNOctaveLayers()

    - #### getNOctaves

          public int getNOctaves()

    - #### setExtended

          public void setExtended(boolean extended)

    - #### setHessianThreshold

          public void setHessianThreshold(double hessianThreshold)

    - #### setNOctaveLayers

          public void setNOctaveLayers(int nOctaveLayers)

    - #### setNOctaves

          public void setNOctaves(int nOctaves)

    - #### setUpright

          public void setUpright(boolean upright)

    - #### finalize

          protected void finalize()
                           throws Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `Throwable`

Generated on Wed Oct 9 2019 16:55:37 UTC / OpenCV 3.4.8